<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.50</title>
    <link rel="stylesheet" href="30.50.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="row Page">
        <div class="col-7 Left-content">
            <h2 class="h2">Contact Us</h2>
            <h6 class="h6">We’re here to help! Send us your query via the form below or send us an email at
                <a href="helpdesk@gstudio.com" style="color: aqua;">helpdesk@gstudio.com</a> for any issue you’re facing
            </h6>
            <form class="form-3" id="submit">
                <div class="form-group">
                    <label class="label-name text-primary">Name</label>
                    <input type="text" class="form-control text" id="exampleInputName1" placeholder="Name"
                        style="background-color:rgba(244, 244, 244, 1);">
                </div>
                <div class="form-group">
                    <input type="email" class="form-control text" id="exampleInputEmail1" aria-describedby="emailHelp"
                        style="background-color:rgba(244, 244, 244, 1);" placeholder="Email Address">
                </div>
                <div class="form-group">
                    <textarea class="form-control text" id="exampleFormControlTextarea1"
                        style="background-color:rgba(244, 244, 244, 1);" placeholder="Type your message here"
                        rows="3"></textarea>
                </div>
                <button type="submit" class="btn btn-lg"
                    style="color:white;background-color:  rgba(95, 195, 202, 1); width: 40%; margin-left: 70%; margin-top: 10%;">Submit</button>
            </form>
        </div>
        <div class="col-5 right-content">
            <div class="row image"><img class="image-1" src="Tech support call on the computer.png"></div>
        </div>
    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

    var gSubmitFormElement = document.getElementById("submit");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gSubmitFormElement.addEventListener("submit", function (paramEvent) {
        paramEvent.preventDefault();
        Submit();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //function Call API
    function Submit() {
        //Khai báo đối tượng
        var vPersonObj = {
            name: "",
            email: "",
            message: ""
        };
        //B1: thu thập dữ liệu inp
        thuThapDuLieu(vPersonObj);
        //B2: Kiểm tra dữ liệu
        var vDuLieuHopLe = validateData(vPersonObj)
        if(vDuLieuHopLe){
            callAPI(vPersonObj);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu
    function thuThapDuLieu(paramPersonObj) {
        var vNameInput = document.getElementById("exampleInputName1");
        var vEmailInput = document.getElementById("exampleInputEmail1");
        var vMessageInput = document.getElementById("exampleFormControlTextarea1");

        paramPersonObj.name = vNameInput.value.trim();
        paramPersonObj.email = vEmailInput.value.trim();
        paramPersonObj.message = vMessageInput.value.trim();
    }

    //hàm kiểm tra dữ liệu
    function validateData(paramPersonObj) {
        if (paramPersonObj.name === "") {
            alert("Name không được để trống");
            return false;
        }
        if (!paramPersonObj.email.includes("@")) {
            alert("Email không đúng định dạng");
            return false;
        }
        if (paramPersonObj.message === "") {
            alert("Vui lòng nhập vào message");
            return false;
        }
        return true;
    };

    //Gọi API
    function callAPI(paramPersonObj) {
        var vQueryParam = new URLSearchParams(paramPersonObj);
        //chuẩn bị gọi api
        var vXmlHttpLogin = new XMLHttpRequest();
        vXmlHttpLogin.open("GET", gBASE_URL + "?" + vQueryParam.toString(), true);
        vXmlHttpLogin.send();
        vXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginResponseText = vXmlHttpLogin.responseText
                    var vLoginInfo = JSON.parse(vLoginResponseText);
                    console.log(vLoginInfo)
                    if (vLoginInfo.length > 0) {
                        alert("Yêu cầu thành công");
                    }
                    else {
                        alert("yêu cầu không thành công");
                    }
                }
            }
    }

</script>

</html>